/*
 *	Ohio Trollius
 *	RBD
 *
 *	Function:	- blinky, an XLED demo
 *			- turn on/off LEDs at random
 *			- MPI version
 */

#include <mpi.h>
#include <terror.h>

extern double		drand48();


int
main(argc, argv)

int			argc;
char			*argv[];

{
	int		rank;
	int		size;
	int		led;
	int		nleds;
	int		ret;

	MPI_Init(&argc, &argv);

	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if (lam_ledinit(rank, size)) MPI_Abort(MPI_COMM_WORLD, errno);

	nleds = lam_ledgetnum();
	if (nleds < 0) MPI_Abort(MPI_COMM_WORLD, errno);

	for (;;) {
		led = drand48() * nleds;

		ret = (drand48() < 0.5) ? lam_ledon(led) : lam_ledoff(led);

		if (ret) {
			MPI_Abort(MPI_COMM_WORLD, errno);
			break; /* fool whining compilers */
		}

		microsleep(10000);
	}

	return(0);
}
