/*
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the XLED software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * XLED source distribution.
 *
 * $Id: ledreq.h,v 1.2 2002/12/11 19:06:38 brbarret Exp $
 * 
 *	Function:	- LEDs templates and constants
 */

#ifndef _LEDREQ
#define _LEDREQ

#include <portable.h>

/*
 * constants
 */
#define LEMAXNLEDS	((int4) 6)	/* max # of LEDs */

/*
 * ledd requests
 */
#define LEQINIT		((int4) 0)	/* initialize LEDs */
#define LEQON		((int4) 1)	/* turn LEDs on */
#define LEQOFF		((int4) 2)	/* turn LEDs off */
#define LEQSTATE	((int4) 3)	/* LEDs status */

/*
 * structures
 */
struct lereq {				/* LED request */
	int4		leq_req;	/* request code */
	int4		leq_src_node;	/* client nodeid */
	int4		leq_src_event;	/* client event */
	int4		leq_nprocs;	/* # of processes */
	int4		leq_proc;	/* process */
	int4		leq_mask;	/* LEDs mask */
};

struct lereply {			/* LED reply */
	int4		ler_ret;	/* return value */
	int4		ler_errno;	/* error code */
	int4		ler_nleds;	/* # LEDs */
	int4		ler_mask;	/* LEDs mask */
};

struct lestate {			/* LED state info. */
	int4		les_nleds;	/* # LEDs */
	int4		les_mask;	/* LEDs mask */
};

/*
 * prototypes
 */
#ifndef __ARGS
#if defined(__STDC__) || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int	lam_ledinit __ARGS((int4 proc, int4 nproc));
extern int	lam_ledclr __ARGS((void));
extern int	lam_ledoff __ARGS((int lednum));
extern int	lam_ledon __ARGS((int lednum));
extern int	lam_ledisset __ARGS((int lednum));
extern int	lam_ledgetnum __ARGS((void));
extern int	lam_rledinit __ARGS((int4 node, int4 proc, int4 nproc));
extern int	lam_rledclr __ARGS((int4 node));
extern int	lam_rledoff __ARGS((int4 node, int lednum));
extern int	lam_rledon __ARGS((int4 node, int lednum));
extern int	lam_rledisset __ARGS((int4 node, int lednum));
extern int	lam_rledgetnum __ARGS((int4 node));
extern int	lam_rledop __ARGS((int4 nodeid, int4 reqcode,
				int4 proc, int4 nproc, int4 mask));
extern int	lam_rledstate __ARGS((int4 node, int4 proc,
					struct lestate *pledstate));

#ifdef __cplusplus
}
#endif

#endif	/* _LEDREQ */
